// channels.cpp Георги Георгиев (Скелета)
// Задача: Разширяване на канали

#include <algorithm>
#include <cstdio>
#include <map>
#include <vector>
#include <queue>
#include <time.h>
#include <limits.h>
using namespace std;

const int MaxVertex=1001;
int E[MaxVertex][MaxVertex], D[MaxVertex], Pi[MaxVertex];
bool Marked[MaxVertex];
int N,M,K;


void input()
{
  int u,v,w;
  scanf("%d %d", &N, &M);
  for(int i=1; i<=N; i++)
   for (int j=1; j<=N; j++)
    E[i][j]=0;
  for(int i=1; i<=M; i++)
  {
   scanf("%d %d %d", &u, &v, &w);
   E[u][v]=w;
   E[v][u]=w;
  }
  scanf("%d", &K);
}

void CreateMST(int s)
{
  int u,v,w,cnt;
  for(int i=1; i<=N; i++)
   { D[i]=0; Pi[i]=-1; Marked[i]=false; }
  D[s]=INT_MAX; // MaxSpaningTree !!
  cnt=1; // колко върха са в T (в началото s е в Т)
  while (cnt<=N) {
   w=0; u=0;
   for(int i=1; i<=N; i++)
     if ((D[i]>w) && (!Marked[i]))
       {w=D[i]; u=i;}
   Marked[u]=true;
//   if (u != s) printf("%d %d %d\n",u, Pi[u], D[u]);
   for(int v=1; v<=N; v++)
     if ((D[v]<E[u][v]) && (!Marked[v]))
       {D[v]=E[u][v]; Pi[v]=u;}
   cnt++;
  }
// Ребрата в T са <v,Pi(v)>, а теглата им са d[v], за v \neq s
}

void SolveP2()
{
  int l;
  l=0;
  for (int v=1; v<=N; v++)
   if ((Pi[v]>0) && (D[v]<K))
    l++;
//  printf("Short_chanels = %d\n",l);
  printf("%d\n",l);
}

main()
{
  input();
  CreateMST(1);
  SolveP2();
}
